# Top
module GreenHat
  # Log
  module Formatters
    # ==========================================================================
    # Formatters
    # ==========================================================================
    # Primarily for gitlab-rails/api_json.log
    def format_api_json
      self.result = raw.map do |row|
        result = Oj.load row

        # Parsing Time
        format_json_traverse result

        flatten_hash(result).sort.to_h
      rescue StandardError => e
        # TODO: Background Logger?
        e.message
        LogBot.warn('JSON Parse', e.message)
        next
      end

      :ok
    end

    def flatten_hash(param, prefix = nil)
      param.each_pair.reduce({}) do |a, (k, v)|
        v.is_a?(Hash) ? a.merge(flatten_hash(v, "#{prefix}#{k}.")) : a.merge("#{prefix}#{k}".to_sym => v)
      end
    end
    # ==========================================================================
  end
end
