# Top
module GreenHat
  # Log
  module Formatters
    # ==========================================================================
    # Formatters
    # ==========================================================================
    def format_json_shell
      self.result = raw.map do |row|
        result = begin
          Oj.load row
        rescue EncodingError
          json_shellwords_fallback row
        end

        # Parsing Time
        format_json_traverse result

        result.sort.to_h
      rescue StandardError => e
        LogBot.warn('JSON Parse', e.message)
        next
      end

      :ok
    end

    def json_shellwords_fallback(row)
      result = Shellwords.split(row).each_with_object({}) do |x, h|
        key, value = x.split('=')
        next if value.nil?

        h[key] = value.numeric? ? value.to_f : value
      end
      result.time = Time.parse result.time if result.key? 'time'

      result
    end
    # ==========================================================================
  end
end
